//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int    Length             = 7;       // Price Channel Period
extern double Risk               = 3;       // Risk Factor in units (0...10) 
extern bool   UseReEntry         = true;    // Re-Entry Mode: 0-off,1-on
extern int    Price              = 0;

extern string note               = "turn on Alert = true; turn off = false";
extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = false;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = true;
extern bool   alertsEmail        = false;
extern bool   alertsNotify       = false;
extern string soundFile          = "alert2.wav";

//
//
//
//
//

double UpSignal[];
double DnSignal[]; 
double UpEntry[];
double DnEntry[]; 
double smax[];
double smin[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpSignal); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108); SetIndexLabel(0,"UpSignal");
   SetIndexBuffer(1,DnSignal); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108); SetIndexLabel(1,"DnSignal");
   SetIndexBuffer(2,UpEntry);  SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,241); SetIndexLabel(2,"UpRe-Entry");
   SetIndexBuffer(3,DnEntry);  SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,242); SetIndexLabel(3,"DnRe-Entry");
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,trend);
   IndicatorShortName(timeFrameToString(TimeFrame)+" PriceChannel_Signal("+Length+")");
return(0);
}

//
//
//
//
//

int start()
{
   
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*TimeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
     int y = iBarShift(NULL,TimeFrame,Time[i]);
     double price  = iMA(NULL,TimeFrame,1,0,0,Price,y);
     double price1 = iMA(NULL,TimeFrame,1,0,0,Price,y+1);    
     double hi     = High[iHighest(NULL,TimeFrame,MODE_HIGH,Length,y)];   
     double lo     =  Low[iLowest( NULL,TimeFrame,MODE_LOW, Length,y)];
     
     smax[i] = hi - (33-Risk)*(hi-lo)/100;
     smin[i] = lo + (33-Risk)*(hi-lo)/100; 
     trend[i]=trend[i+1]; 
	  if (price > smax[i]) trend[i] = 1; 
	  if (price < smin[i]) trend[i] =-1;
	
	  //
	  //
	  //
	  //
	  //
	     
	  DnSignal[i] = EMPTY_VALUE;
     DnEntry[i]  = EMPTY_VALUE;
     UpEntry[i]  = EMPTY_VALUE;
     UpSignal[i] = EMPTY_VALUE;

        if (trend[i]>0)
	     {
	       if (trend[i+1]<0)                                                                       UpSignal[i] = Low[i]-0.5*iATR(NULL,0,Length,i);
	       if (UseReEntry && price > smax[i] && price1 <= smax[i+1] && UpSignal[i] == EMPTY_VALUE) UpEntry[i]  = Low[i]-0.5*iATR(NULL,0,Length,i); 
	
	     }
	  
	     if (trend[i]<0)
	     {
	       if (trend[i+1]>0)                                                                        DnSignal[i] = High[i]+0.5*iATR(NULL,0,Length,i);
	       if (UseReEntry && price < smin[i] && price1 >= smin[i+1] && DnSignal[i] == EMPTY_VALUE)  DnEntry[i]  = High[i]+0.5*iATR(NULL,0,Length,i); 
	     }
   	         

	} 	         
   
   //
   //
   //
   //
   //
   
   //
	//
	//
	//
	//
	
	if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar));
  
      if (UpSignal[whichBar] != EMPTY_VALUE && UpSignal[whichBar+1] == EMPTY_VALUE) doAlert(whichBar,"up");
      if (DnSignal[whichBar] != EMPTY_VALUE && DnSignal[whichBar+1] == EMPTY_VALUE) doAlert(whichBar,"down");
      if (UpEntry[whichBar]  != EMPTY_VALUE && UpEntry[whichBar+1]  == EMPTY_VALUE) doAlert(whichBar,"Re-entry for buy");
      if (DnEntry[whichBar]  != EMPTY_VALUE && DnEntry[whichBar+1]  == EMPTY_VALUE) doAlert(whichBar,"Re-entry for sell");       
   } 	         
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," PriceChannel Signal ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " PriceChannel Signal "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

  

